# -*- coding: utf-8 -*-

"""
dropbox

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from dropbox.api_helper import APIHelper
from dropbox.configuration import Server
from dropbox.controllers.base_controller import BaseController
from apimatic_core.request_builder import RequestBuilder
from apimatic_core.response_handler import ResponseHandler
from apimatic_core.types.parameter import Parameter
from dropbox.http.http_method_enum import HttpMethodEnum
from apimatic_core.authentication.multiple.single_auth import Single
from dropbox.models.response import Response


class FilesController(BaseController):

    """A Controller to access Endpoints in the dropbox API."""
    def __init__(self, config):
        super(FilesController, self).__init__(config)

    def get_file_count(self):
        """Does a POST request to /file_requests/count.

        Returns:
            Response: Response from the API.

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/file_requests/count')
            .http_method(HttpMethodEnum.POST)
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .auth(Single('httpACG'))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(Response.from_dictionary)
        ).execute()
