# -*- coding: utf-8 -*-

"""
dropbox

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from apimatic_core.configurations.global_configuration import GlobalConfiguration
from apimatic_core.decorators.lazy_property import LazyProperty
from dropbox.configuration import Configuration
from dropbox.controllers.base_controller import BaseController
from dropbox.configuration import Environment
from dropbox.http.auth.o_auth_2 import OAuth2
from dropbox.controllers.files_controller import FilesController
from dropbox.controllers.o_auth_authorization_controller\
    import OAuthAuthorizationController


class DropboxClient(object):
    @LazyProperty
    def files(self):
        return FilesController(self.global_configuration)

    @LazyProperty
    def o_auth_authorization(self):
        return OAuthAuthorizationController(self.global_configuration)

    @property
    def http_acg(self):
        return self.auth_managers['httpACG']

    def __init__(self, http_client_instance=None,
                 override_http_client_configuration=False, http_call_back=None,
                 timeout=60, max_retries=0, backoff_factor=0,
                 retry_statuses=None, retry_methods=None,
                 environment=Environment.PRODUCTION,
                 basepath='api.dropboxapi.com', o_auth_client_id=None,
                 o_auth_client_secret=None, o_auth_redirect_uri=None,
                 o_auth_token=None, authorization_code_auth_credentials=None,
                 config=None):
        self.config = config or Configuration(
            http_client_instance=http_client_instance,
            override_http_client_configuration=override_http_client_configuration,
            http_call_back=http_call_back, timeout=timeout,
            max_retries=max_retries, backoff_factor=backoff_factor,
            retry_statuses=retry_statuses, retry_methods=retry_methods,
            environment=environment, basepath=basepath,
            o_auth_client_id=o_auth_client_id,
            o_auth_client_secret=o_auth_client_secret,
            o_auth_redirect_uri=o_auth_redirect_uri, o_auth_token=o_auth_token,
            authorization_code_auth_credentials=authorization_code_auth_credentials)

        self.global_configuration = GlobalConfiguration(self.config)\
            .global_errors(BaseController.global_errors())\
            .base_uri_executor(self.config.get_base_uri)\
            .user_agent(BaseController.user_agent(), BaseController.user_agent_parameters())

        self.auth_managers = {key: None for key in ['httpACG']}
        self.auth_managers['httpACG'] = OAuth2(
            self.config.authorization_code_auth_credentials,
            self.global_configuration)
        self.global_configuration = self.global_configuration.auth_managers(self.auth_managers)

